C   ***   DSROTG
C
      SUBROUTINE DSROTG(SA,SB,C,S)
C
C     CONSTRUCT GIVENS PLANE ROTATION.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION SA,SB,C,S,ROE,SCALE,R,Z
C
      ROE = SB
      IF( DABS(SA) .GT. DABS(SB) ) ROE = SA
      SCALE = DABS(SA) + DABS(SB)
      IF( SCALE .NE. 0.0 ) GO TO 10
         C = 1.0
         S = 0.0
         R = 0.0
         GO TO 20
   10 R = SCALE*DSQRT((SA/SCALE)**2 + (SB/SCALE)**2)
      R = DSIGN(dble(1.0),ROE)*R
      C = SA/R
      S = SB/R
   20 Z = 1.0
      IF( DABS(SA) .GT. DABS(SB) ) Z = S
      IF( DABS(SB) .GE. DABS(SA) .AND. C .NE. 0.0 ) Z = 1.0/C
      SA = R
      SB = Z
      RETURN
      END
